#include <openssl/ssl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/timeb.h>

#include "openssl/bn.h"
#include <gmp.h>
#include "openssl/rsa.h"
#include "openssl/dsa.h"
#include "openssl/dh.h"

#include "parameters.h"
#include "tools.h"

int main(int argc, char *argv[])
{ 
	double t_keygen=0.0;
	RSA *params = RSA_new();
	F_Time(START);	
	params = RSA_generate_key(rsa_key_length, rsa_pub_exp, NULL, NULL);
	t_keygen+=F_Time(STOP);

	FILE *fp=fopen("rsa.pub", "w");
	fprintf(fp, "%s\n", BN_bn2hex(params->n));
	fprintf(fp, "%s\n", BN_bn2hex(params->e));
	fclose(fp);

	fp=fopen("rsa.prv", "w");
	fprintf(fp, "%s\n", BN_bn2hex(params->d));
	fprintf(fp, "%s\n", BN_bn2hex(params->p));
	fprintf(fp, "%s\n", BN_bn2hex(params->q));
	fprintf(fp, "%s\n", BN_bn2hex(params->dmp1));
	fprintf(fp, "%s\n", BN_bn2hex(params->dmq1));
	fprintf(fp, "%s\n", BN_bn2hex(params->iqmp));
	fclose(fp);
}	

