#include <openssl/ssl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/timeb.h>

#include "openssl/bn.h"
#include <gmp.h>
#include "openssl/rsa.h"
#include "openssl/dsa.h"
#include "openssl/dh.h"

#include "parameters.h"


int main(int argc, char *argv[])
{ 
	int i, j, n_s, n_c;

	if(argc != 3) {
		printf("ERROR\n");
		printf("Usage ./sets n_s n_c\n");
		exit(-1);
	}
	n_s=atoi(argv[1]);	
	n_c=atoi(argv[2]);	



	BIGNUM **S=malloc(n_s*sizeof(BIGNUM *));
	BIGNUM **C=malloc(n_c*sizeof(BIGNUM *));

	FILE *fp=fopen("server.dat","w");
	for (j=0; j<n_s;j++) {
		S[j] = BN_new();
		BN_rand(S[j], 160, 1, 0);
		fprintf(fp,"%s\n", BN_bn2hex(S[j]));
	}
	fclose(fp);
	fp=fopen("client.dat","w");
	for (i=0; i<n_c;i++) {
		C[i] = BN_new();
		BN_rand(C[i], 160, 1, 0);
		fprintf(fp,"%s\n", BN_bn2hex(C[i]));
	}

	fclose(fp);
}
	

